/* GCC */
#include <fstream>
#include <cstring>
#include <vector>

using namespace std;

template<typename _InIt1, typename _InIt2>
void prefix_function(_InIt1 _1_first, _InIt1 _1_last,
                     _InIt2 _2_first, bool* prefixes)
{
    static vector<size_t> pf(100000);
    static size_t j;
    const size_t n = _1_last - _1_first;
    pf[0] = 0;
    for(size_t i = 1; i < n; ++i)
    {
        j = pf[i-1];
        while(j > 0 && *(_1_first+j) != *(_2_first+i))
            j = pf[j-1];
        if(*(_1_first+j) == *(_2_first+i))
            pf[i] = pf[j]+1;
    }
    for(size_t i = pf[n-1]; i > 0; i = pf[i-1])
        prefixes[i-1] = true;
}

bool b1[100000], b2[100000];

int main(void)
{
    ios_base::sync_with_stdio(false);
    size_t t, n, tmp1, tmp2;
    ifstream in("symmetry.in");
    in >> t;
    ofstream out("symmetry.out");
    while(t--)
    {
        in >> n;
        vector<size_t> v(n-1);
        in >> tmp1;
        for(size_t i = 0; i < n-1; ++i)
        {
            in >> tmp2;
            v[i] = tmp2 - tmp1;
            tmp1 = tmp2;
        }
        memset(b1, n, false);
        memset(b2, n, false);
        prefix_function(v.begin(), v.end(), v.rbegin(), b1);
        prefix_function(v.rbegin(), v.rend(), v.begin(), b2);
        bool found = false;
        if(b2[n-3])
        {
            out << "1\n";
            found = true;
        }
        if(!found)
            for(size_t i = 0; i < n-3; ++i)
                if(b1[i] && b2[n-4-i])
                {
                    out << i+2 << '\n';
                    found = true;
                    break;
                }
        if(!found && b1[n-3])
        {
            out << n-1 << '\n';
            found = true;
        }
        if(!found)
            out << "0\n";
    }
    in.close();
    out.close();
    return 0;
}
