/* GCC */

#include <vector>
#include <cstdio>
#include <string>
#include <algorithm>
#include <map>
#include <functional>
using namespace std;

#define NAME "aliens"

vector<pair<int, string> > dict;
vector<vector<int> > p;
int n, m, k;

void backtrack(int i, vector<int>& a)
{
    if (i == m) {
        int sum = 0;
        string s;
        for (int j = 0; j < m; ++j) {
            sum += p[j][a[j]];
            s += 'a'+a[j];
        }
        dict.push_back(make_pair(sum, s));

    }
    else {
        for (int j = 0; j < n; ++j) {
            a[i] = j;
            backtrack(i+1, a);
        }
    }

}

bool comp(const pair<int, string>& a,const pair<int, string>& b)
{
    if (a.first > b.first)
        return true;
    else if (a.first < b.first)
        return false;
    else if (a.second < b.second)
        return true;
    else
        return false;
}

int main()
{
    FILE *fin = fopen(NAME ".in", "r");
    FILE *fout = fopen(NAME ".out", "w");

    fscanf(fin, "%d %d %d", &n, &m, &k);

    for (int i = 0; i < m; ++i) {
        p.push_back(vector<int>());
        for (int j = 0; j < n; ++j) {
            int t;
            fscanf(fin, "%d", &t);
            p[i].push_back(t);
        }
    }
    vector<int> t(m);

    backtrack(0, t);

    sort(dict.begin(), dict.end(), comp);

    fprintf(fout, "%s\n", dict[k-1].second.c_str());
    fclose(fin);
    fclose(fout);
    return 0;
}
