/* GCC */

#include <iostream>
#include <vector>
#include <cstdio>
#include <cstring>
#include <ctime>
#include <cstdlib>
#include <stdint.h>
using namespace std;

#define NAME "symmetry"

#define SZ 100000

#define N 40000

#define A 15071

int main()
{
    FILE *fin = fopen(NAME ".in", "r");
    FILE *fout = fopen(NAME ".out", "w");

    int tests;
    fscanf(fin, "%d", &tests);

    for (int zq = 0; zq < tests; ++zq)
    {
        int n;
        fscanf(fin, "%d", &n);
        static int input[SZ];

        for (int i = 0; i < n; ++i)
            fscanf(fin, "%d", &input[i]);

        if (n == 1) {
            fprintf(fout, "%d\n", 0);
            continue;
        }
        if (n == 2) {
            fprintf(fout, "%d\n", 1);
            continue;
        }
        if (n == 3) {
            fprintf(fout, "%d\n", 1);
            continue;
        }

        for (int i = 0; i < n - 1; ++i)
            input[i] = input[i + 1] - input[i];
        --n;
/*
        for (int i = 0; i < n; ++i)
            cout << input[i] << ' ';
        cout << endl;
*/
        static int64_t h[SZ], h_rev[SZ], g[SZ], g_rev[SZ];

        h[0] = g[0] = input[0];
        h_rev[n-1] = g_rev[n-1] = input[n-1];

        int a = A;

        for (int i = 1; i < n; ++i) {
            h[i] = (h[i-1] + input[i]*a%N) % N;
            g[i] = (g[i-1]*A%N + input[i]) % N;
            a = (a*A) % N;
        }

        a = A;

        for (int i = n-2; i >= 0; --i) {
            h_rev[i] =(h_rev[i+1] + input[i]*a%N) % N;
            g_rev[i] = (g_rev[i+1]*A%N + input[i]) % N;
            a = (a*A) % N;
        }

        int ans = -1;
        for (int i = 0; i < n-2; ++i)
            if (h[i] == g[i] && h_rev[i+2] == g_rev[i+2]) {
                ans = i;
                break;
            }
        if (ans == -1)
            fprintf(fout, "%d\n", 0);
        else if (h_rev[1] == g_rev[1] && ans == 0)
            fprintf(fout, "%d\n", 1);
        else
            fprintf(fout, "%d\n", ans+2);

/*
        printf("h: ");
        for (int i = 0; i < n; ++i) {
            printf("%6d", h[i]);
        }
        printf("\ng: ");
        for (int i = 0; i < n; ++i) {
            printf("%6d", g[i]);
        }
        printf("\n");

        printf("h_rev: ");
        for (int i = 0; i < n; ++i) {
            printf("%6d", h_rev[i]);
        }
        printf("\ng_rev: ");
        for (int i = 0; i < n; ++i) {
            printf("%6d", g_rev[i]);
        }
        printf("\n");
*/

    }

    fclose(fin);
    fclose(fout);
    return 0;
}
